Index: Singular/LIB/tropical.lib
===================================================================
--- Singular/LIB/tropical.lib	(revision fba86f89b3458187b40c5f0d5f6408412d98d295)
+++ Singular/LIB/tropical.lib	(revision 7d56875cf7720719f5b6acd193768a4d5b57848f)
@@ -1,3 +1,3 @@
-version="$Id: tropical.lib,v 1.7 2008-08-20 17:36:04 keilen Exp $";
+version="$Id: tropical.lib,v 1.8 2008-10-09 09:31:58 Singular Exp $";
 category="Tropical Geometry";
 info="
@@ -8,5 +8,5 @@
 @*               Thomas Markwig,  email: keilen@mathematik.uni-kl.de
 
-WARNING: 
+WARNING:
      - tropicalLifting will only work under LINUX and if in addition gfan is installed.
 @*   - drawTropicalCurve and drawTropicalNewtonSubdivision will only display the tropical
@@ -20,8 +20,8 @@
      the torus is embedded via the map sending a point x in (K*)^n to the point (x^v0,...,x^vm).
      The generic hyperplane sections are just the images of the hypersurfaces in (K*)^n defined by
-     the polynomials f=a0*x^v0+...+am*x^vm=0. Some properties of these hypersurfaces can be studied 
-     via tropicalisation. 
-
-     For this we suppose that K=C{{t}} is the field of Puiseux series over the field of complex 
+     the polynomials f=a0*x^v0+...+am*x^vm=0. Some properties of these hypersurfaces can be studied
+     via tropicalisation.
+
+     For this we suppose that K=C{{t}} is the field of Puiseux series over the field of complex
      numbers (or any other field with a valuation into the real numbers). One associates to the
      hypersurface given by f=a0*x^v0+...+am*x^vm the tropical hypersurface defined by the tropicalisation
@@ -29,8 +29,8 @@
      of the integer vector v in Z^n with the vector x=(x1,...,xn) of variables, so that trop(f) is
      a piecewise linear function on R^n. The corner locus of this function (i.e. the points at which
-     the minimum is attained a least twice) is the tropical hypersurface defined by trop(f). 
+     the minimum is attained a least twice) is the tropical hypersurface defined by trop(f).
      The theorem of Newton-Kapranov states that this tropical hypersurface is the same as if one
      computes pointwise the valuation of the hypersurface given by f. The analogue holds true if one
-     replaces one equation f by an ideal I. A constructive proof of the theorem is given by an adapted 
+     replaces one equation f by an ideal I. A constructive proof of the theorem is given by an adapted
      version of the Newton-Puiseux algorithm. The hard part is to find a point in the variety over
      C{{t}} which corresponds to a given point in the tropical variety.
@@ -39,6 +39,6 @@
      Of course we cannot represent the field of Puiseux series over C in its full strength, however,
      in order to compute interesting examples it will be sufficient to replace the complex numbers C
-     by the rational numbers Q and to replace Puiseux series in t by rational functions in t, 
-     i.e. we replace C{{t}} by Q(t), or sometimes even by Q[t]. Note, that this in particular 
+     by the rational numbers Q and to replace Puiseux series in t by rational functions in t,
+     i.e. we replace C{{t}} by Q(t), or sometimes even by Q[t]. Note, that this in particular
      forbits rational exponents for the t's.
 
@@ -48,7 +48,7 @@
      If, however, for some reason you prefer to work with general vi, then you have to pass right away to
      the tropicalisation of the equations, whereever this is allowed -- these are linear polynomials
-     where the constant coefficient correspond to the valuation of the original coefficient and where 
+     where the constant coefficient correspond to the valuation of the original coefficient and where
      the non-constant coefficient correspond to the exponents of the monomials, thus they may be rational
-     numbers respectively negative numbers: 
+     numbers respectively negative numbers:
      e.g. if f=t^{1/2}*x^{-2}*y^3+2t*x*y+4  then  trop(f)=min{1/2-2x+3y,1+x+y,0}.
 
@@ -59,5 +59,5 @@
                           I have to be in the polynomial ring Q[t,x1,...,xn] considered as a subring of
                           C{{t}}[x1,...,xn]; a solution will be constructed up to given order; note that
-                          several field extensions of Q might be necessary thoughout the intermediate 
+                          several field extensions of Q might be necessary thoughout the intermediate
                           computations; the procedures uses the external program gfan
 @*   - drawTropicalCurve  visualises a tropical plane curve either given by a polynomial in Q(t)[x,y]
@@ -66,5 +66,5 @@
 @*   - tropicalJInvariant computes the tropical j-invaiant of a tropical elliptic curve
 @*   - jInvariant         computes the j-invariant of an elliptic curve
-@*   - weierstrassFom     computes the Weierstrass form of an elliptic curve     
+@*   - weierstrassFom     computes the Weierstrass form of an elliptic curve
 
 PROCEDURES CONCERNED WITH TROPICAL LIFTING:
@@ -93,10 +93,10 @@
 PROCEDURES CONCERNED WITH THE LATEX CONVERSION:
      texNumber(poly)                  outputs the texcommand for the leading coefficient of poly
-     texPolynomial(poly)              outputs the texcommand for the polynomial poly 
+     texPolynomial(poly)              outputs the texcommand for the polynomial poly
      texMatrix(matrix)                outputs the texcommand for the matrix
      texDrawBasic(list)               embeds the output of texDrawTropical in a texdraw environment
      texDrawTropical(list)            computes the texdraw commands for a tropical curve
-     texDrawNewtonSubdivision(list)   computes the texdraw commands for a Newton subdivision 
-     texDrawTriangulation(list,list)  computes the texdraw commands for a triangulation     
+     texDrawNewtonSubdivision(list)   computes the texdraw commands for a Newton subdivision
+     texDrawTriangulation(list,list)  computes the texdraw commands for a triangulation
 
 AUXILARY PROCEDURES:
@@ -108,5 +108,5 @@
      dualConic(poly)                  computes the dual of the affine plane conic defined by poly
      parameterSubstitute(poly,int)    substitutes in the poly the parameter t by t^N
-     tropcialSubst(poly,int,list)     computes the tropical polynomial of poly with certain substitutions 
+     tropcialSubst(poly,int,list)     computes the tropical polynomial of poly with certain substitutions
      randomPoly(int,int,int)          computes a polynomial with random coefficients
      cleanTmp()                       removes the latex and ps files from /tmp created by other procedures
@@ -137,5 +137,5 @@
 /// - eliminatecomponents
 /// - findzerosAndBasictransform
-/// - ordermaximalideals 
+/// - ordermaximalideals
 /// - verticesTropicalCurve
 /// - bunchOfLines
@@ -186,16 +186,16 @@
 
 ////////////////////////////////////////////////////////////////////////////////////
-/// Procedures concerned with tropical parametrisation 
-///////////////////////////////////////////////////////////////////////////////////  
+/// Procedures concerned with tropical parametrisation
+///////////////////////////////////////////////////////////////////////////////////
 
 proc tropicalLifting (ideal i,intvec w,int ordnung,list #)
 "USAGE:  tropicalLifting(i,w,ord[,opt]); i ideal, w intvec, ord int, opt string
-ASSUME:  - i is an ideal in Q[t,x_1,...,x_n], w=(w_0,w_1,...,w_n)  
-           and (w_1/w_0,...,w_n/w_0) is in the tropical variety of i, 
-           and ord is the order up to which a point in V(i) over Q{{t}} lying over 
+ASSUME:  - i is an ideal in Q[t,x_1,...,x_n], w=(w_0,w_1,...,w_n)
+           and (w_1/w_0,...,w_n/w_0) is in the tropical variety of i,
+           and ord is the order up to which a point in V(i) over Q{{t}} lying over
            (w_1/w_0,...,w_n/w_0) shall be computed; w_0 may NOT be ZERO
-@*       - the basering should not have any parameters on its own 
+@*       - the basering should not have any parameters on its own
            and it should have a global monomial ordering, e.g. ring r=0,(t,x(1..n)),dp;
-@*       - the first variable of the basering will be treated as the parameter t 
+@*       - the first variable of the basering will be treated as the parameter t
            in the Puiseux series field !!!!
 @*       - the optional parameter opt should be one or more strings among the following:
@@ -203,5 +203,5 @@
 @*         'isPrime'            : the ideal is prime over Q(t)[x_1,...,x_n]  (not to be checked);
 @*         'isInTrop'           : (w_1/w_0,...,w_n/w_0) is in the tropical variety (not to be checked);
-@*         'oldGfan'            : uses gfan version 0.2.1 or less 
+@*         'oldGfan'            : uses gfan version 0.2.1 or less
 @*         'findAll'            : find all solutions of a zero-dimensional ideal over (w_1/w_0,...,w_n/w_0)
 @*         'noAbs'              : do NOT use absolute primary decomposition
@@ -226,8 +226,8 @@
                in the tropical variety of i to a point in V(i) over Puiseux series field up to
                the first ord terms, if the ideal is zero-dimensional over Q{{t}};
-               more precisely, each entry of the list is a list l as computed if 
+               more precisely, each entry of the list is a list l as computed if
                'find_all' was NOT set
 @*       WE NOW DESCRIBE THE LIST ENTRIES IF 'findAll' WAS NOT SET:
-@*       - the ring l[1] contains an ideal LIFT, which contains 
+@*       - the ring l[1] contains an ideal LIFT, which contains
            a point in V(i) lying over w up to the first ord terms;
 @*       - and if the integer l[2] is N then t has to be replaced by t^1/N in the
@@ -235,5 +235,5 @@
 @*       - if the k+1st entry of l[3] is  non-zero, then the kth component of LIFT has to
            be multiplied t^(-l[3][k]/l[3][1]) AFTER substituting t by t^1/N
-@*       - unless the option 'noResubst' was set, the kth entry of list l[4] 
+@*       - unless the option 'noResubst' was set, the kth entry of list l[4]
            is a string which represents the kth generator of
            the ideal i where the coordinates have been replaced by the result of the lift;
@@ -246,5 +246,5 @@
 @*       - if the parameter 'findAll' is set AND the ideal i is zero-dimensional in Q{{t}}[x_1,...,x_n]
            then ALL points in V(i) lying over w are computed up to order ord; if the ideal
-           is not-zero dimenisonal, then only all points in the ideal after cutting down 
+           is not-zero dimenisonal, then only all points in the ideal after cutting down
            to dimension zero will be computed
 @*       - the procedure REQUIRES that the program GFAN is installed on your computer;
@@ -263,10 +263,10 @@
              and thus there may not exist a point in V(i) over the Puiseux series field
              with the desired valuation; so there is no chance that the procedure produced
-             a sensible output - e.g. if i=tx^p-tx-1 
-@*         + if the dimension of i over Z/pZ(t) is not zero the process of reduction to 
+             a sensible output - e.g. if i=tx^p-tx-1
+@*         + if the dimension of i over Z/pZ(t) is not zero the process of reduction to
              zero might not work if the characteristic is small and you are unlucky
-@*         + the option 'noAbs' has to be used since absolute primary decomposition in 
+@*         + the option 'noAbs' has to be used since absolute primary decomposition in
              Singular only works in characteristic zero
-@*       - the basefield should either be Q or Z/pZ for some prime p; field extensions 
+@*       - the basefield should either be Q or Z/pZ for some prime p; field extensions
            will be computed where necessary; if you need parameters or field extensions
            from the beginning they should rather be simulated as variables possibly adding
@@ -346,5 +346,5 @@
   {
     Error("The first coordinate of your input w must be NON-ZERO, since it is a DENOMINATOR!");
-  } 
+  }
   // if w_0<0, then replace w by -w, so that the "denominator" w_0 is positive
   if (w[1]<0)
@@ -362,5 +362,5 @@
     w[1]=-1;
   }
-  // if some entry of w is positive, we have to make a transformation, 
+  // if some entry of w is positive, we have to make a transformation,
   // which moves it to something non-positive
   for (j=2;j<=nvars(basering);j++)
@@ -387,12 +387,12 @@
   {
     variablen=variablen+var(j);
-  }    
+  }
   map GRUNDPHI=BASERING,t,variablen;
   ideal i=GRUNDPHI(i);
-  // compute the initial ideal of i and test if w is in the tropical variety of i 
+  // compute the initial ideal of i and test if w is in the tropical variety of i
   // - the last entry 1 only means that t is the last variable in the ring
   ideal ini=tInitialIdeal(i,w,1);
   if (isintrop==0) // test if w is in trop(i) only if isInTrop has not been set
-  {    
+  {
     poly product=1;
     for (j=1;j<=nvars(basering)-1;j++)
@@ -418,8 +418,8 @@
       // the procedurce cutdown computes a new ring, in which there lives a zero-dimensional
       // ideal which has been computed by cutting down the input with generic linear forms
-      // of the type x_i1-p_1,...,x_id-p_d for some polynomials p_1,...,p_d not depending 
+      // of the type x_i1-p_1,...,x_id-p_d for some polynomials p_1,...,p_d not depending
       // on the variables x_i1,...,x_id; that way we have reduced the number of variables by dd !!!
       // the new zero-dimensional ideal is called i, its t-initial ideal (with respect to
-      // the new w=CUTDOWN[2]) is ini, and finally there is a list repl in the ring 
+      // the new w=CUTDOWN[2]) is ini, and finally there is a list repl in the ring
       // which contains at the polynomial p_j at position i_j and a zero otherwise;
       if (isprime==0) // the minimal associated primes of i are computed
@@ -461,5 +461,5 @@
     for (jj=1;jj<=size(TP);jj++)
     {
-      // the list TP contains as a first entry the ring over which the tropical parametrisation 
+      // the list TP contains as a first entry the ring over which the tropical parametrisation
       // of the (possibly cutdown ideal) i lives
       def LIFTRING=TP[jj][1];
@@ -493,9 +493,9 @@
         }
         setring LIFTRING;
-        ideal LIFT=imap(REPLACEMENTRING,LIFT);    
-        // test now if the LIFT has the correct valuation !!!     
+        ideal LIFT=imap(REPLACEMENTRING,LIFT);
+        // test now if the LIFT has the correct valuation !!!
         // note: it may happen, that when resubstituting PARA into the replacement rules
         //       there occured some unexpected cancellation; we only know that for SOME
-        //       solution of the zero-dimensional reduction NO canellation will occur, 
+        //       solution of the zero-dimensional reduction NO canellation will occur,
         //       but for others this may very well happen; this in particular means that
         //       we possibly MUST compute all zero-dimensional solutions when cutting down!
@@ -548,5 +548,5 @@
           // replace @a by a in minpoly and in LIFT
           map phi=INTERRING,t,a,a;
-          mp=phi(mp);      
+          mp=phi(mp);
           LIFT=phi(LIFT);
           // pass now to a ring whithout @a and with a as parameter
@@ -555,9 +555,9 @@
           ideal LIFT=imap(INTERRING,LIFT);
           kill INTERRING;
-        }    
+        }
         // then export LIFT
-        export(LIFT); 
+        export(LIFT);
         // test the  result by resubstitution
-        setring GRUNDRING;  
+        setring GRUNDRING;
         list resubst;
         if (noresubst==0)
@@ -568,10 +568,10 @@
           }
           else
-          {      
+          {
             resubst=tropicalliftingresubstitute(substitute(i,t,t^(TP[jj][2])),list(LIFTRING),N*TP[jj][2]);
           }
         }
         setring BASERING;
-        // Finally, if t has been replaced by t^N, then we have to change the 
+        // Finally, if t has been replaced by t^N, then we have to change the
         // third entry of TP by multiplying by N.
         if (noabs==1)
@@ -598,5 +598,5 @@
       "The procedure will be restarted with the option 'findAll'.";
       "Go on by hitting RETURN!";
-      findall=1;    
+      findall=1;
       noabs=0;
       setring CUTDOWNRING;
@@ -604,5 +604,5 @@
       "i";i;
       "ini";tInitialIdeal(i,w,1);
-      
+
 /*
       setring GRUNDRING;
@@ -630,24 +630,24 @@
   if (voice+printlevel>=2)
   {
-      
+
       "The procedure has created a list of lists. The jth entry of this list
 contains a ring, an integer and an intvec.
 In this ring lives an ideal representing the wanted lifting,
 if the integer is N then in the parametrisation t has to be replaced by t^1/N,
-and if the ith component of the intvec is w[i] then the ith component in LIFT 
+and if the ith component of the intvec is w[i] then the ith component in LIFT
 should be multiplied by t^-w[i]/N in order to get the parametrisation.
-   
+
 Suppose your list has the name L, then you can access the 1st ring via:
 ";
     if (findall==1)
     {
-      "def LIFTRing=L[1][1]; setring LIFTRing; LIFT; 
+      "def LIFTRing=L[1][1]; setring LIFTRing; LIFT;
 ";
     }
     else
     {
-      "def LIFTRing=L[1]; setring LIFTRing; LIFT; 
+      "def LIFTRing=L[1]; setring LIFTRing; LIFT;
 ";
-    }  
+    }
   }
   if (findall==1) // if all solutions have been computed, return a list of lists
@@ -674,5 +674,5 @@
    def LIFTRing=LIST[1];
    setring LIFTRing;
-   // LIFT contains the first 4 terms of a point in the variety of i 
+   // LIFT contains the first 4 terms of a point in the variety of i
    // over the Puiseux series field C{{t}} whose order is -w[1]/w[0]=1
    LIFT;
@@ -702,5 +702,5 @@
    // NOTE: since the last component of v is positive, the lifting
    //       must start with a negative power of t, which in Singular
-   //       is not allowed for a variable. 
+   //       is not allowed for a variable.
    def LIFTRing3=LIST[1];
    setring LIFTRing3;
@@ -756,22 +756,22 @@
     }
     if (size(troplift)==4) // this means that tropicalLifting was called with absolute primary decomposition
-    {      
+    {
       setring LIFTRing;
       "The lifting of the point in the tropical variety lives in the ring";
       if ((size(LIFTpar)==0) and (N==1))
       {
-        Kstring+"[[t]]"; 
+        Kstring+"[[t]]";
       }
       if ((size(LIFTpar)==0) and (N!=1))
       {
-        Kstring+"[[t^(1/"+string(N)+")]]"; 
+        Kstring+"[[t^(1/"+string(N)+")]]";
       }
       if ((size(LIFTpar)!=0) and (N!=1))
-      {    
-        Kstring+"["+LIFTpar+"]/"+string(minpoly)+"[[t^(1/"+string(N)+")]]";  
+      {
+        Kstring+"["+LIFTpar+"]/"+string(minpoly)+"[[t^(1/"+string(N)+")]]";
       }
       if ((size(LIFTpar)!=0) and (N==1))
-      {    
-        Kstring+"["+LIFTpar+"]/"+string(minpoly)+"[[t]]";  
+      {
+        Kstring+"["+LIFTpar+"]/"+string(minpoly)+"[[t]]";
       }
     }
@@ -790,15 +790,15 @@
       }
       if ((size(LIFTpar)!=0) and (N!=1))
-      {    
-        Kstring+"["+LIFTpar+"]/M[[t^(1/"+string(N)+")]]";  
+      {
+        Kstring+"["+LIFTpar+"]/M[[t^(1/"+string(N)+")]]";
         "where M is the maximal ideal";
         "M=<"+m+">";
       }
       if ((size(LIFTpar)!=0) and (N==1))
-      {    
-        Kstring+"["+LIFTpar+"]/M[[t]]";  
+      {
+        Kstring+"["+LIFTpar+"]/M[[t]]";
         "where M is the maximal ideal";
         "M=<"+m+">";
-      }      
+      }
     }
     "";
@@ -827,5 +827,5 @@
       }
     }
-  }      
+  }
 }
 example
@@ -841,14 +841,14 @@
 
 ////////////////////////////////////////////////////////////////////////////////////
-/// Procedures concerned with drawing a tropical curve or a Newton subdivision 
+/// Procedures concerned with drawing a tropical curve or a Newton subdivision
 ////////////////////////////////////////////////////////////////////////////////////
 proc tropicalCurve (def tp,list #)
 "USAGE:      tropicalCurve(tp[,#]); tp list, # optional list
-ASSUME:      tp is list of linear polynomials of the form ax+by+c with integers a, b and a rational number c 
+ASSUME:      tp is list of linear polynomials of the form ax+by+c with integers a, b and a rational number c
              representing a tropical Laurent polynomial defining a tropical plane curve;
              alternatively tp can be a polynomial in Q(t)[x,y] defining a tropical plane curve
-             via the valuation map; 
+             via the valuation map;
              the basering must have a global monomial ordering, two variables and up to one parameter!
-RETURN:      list, each entry i=1,...,size(l)-1 corresponds to a vertex in the tropical plane 
+RETURN:      list, each entry i=1,...,size(l)-1 corresponds to a vertex in the tropical plane
                    curve defined by tp
                    l[i][1] = x-coordinate of the ith vertex
@@ -857,10 +857,10 @@
                              the tropical curve is connected to the jth vertex with multiplicity given
                              by the corresponding entry in the second row
-                   l[i][4] = list of lists, the first entry of a list is a primitive integer vector 
-                             defining the direction of an unbounded edge emerging from the ith vertex 
+                   l[i][4] = list of lists, the first entry of a list is a primitive integer vector
+                             defining the direction of an unbounded edge emerging from the ith vertex
                              of the graph, the corresponding second entry in the list is the multiplicity
                              of the unbounded edge
                    l[i][5] = a polynomial whose monomials mark the vertices in the Newton polygon
-                             corresponding to the entries in tp which take the common minimum 
+                             corresponding to the entries in tp which take the common minimum
                              at the ith vertex -- if some coefficient a or b of the linear polynomials
                              in the input was negative, then each monomial has to be shifted by
@@ -885,5 +885,5 @@
   }
   // if you insert a single polynomial instead of an ideal representing a tropicalised polynomial,
-  // then we compute first the tropicalisation of this polynomial -- this feature is not 
+  // then we compute first the tropicalisation of this polynomial -- this feature is not
   // documented in the above help string
   if (typeof(tp)=="poly")
@@ -892,5 +892,5 @@
     if ((npars(basering)!=1) or (nvars(basering)!=2))
     {
-      ERROR("The basering should have precisely one parameter and two indeterminates!");      
+      ERROR("The basering should have precisely one parameter and two indeterminates!");
     }
     poly f=tp;
@@ -901,5 +901,5 @@
   if (nvars(basering) != 2)
   {
-    ERROR("The basering should have precisely two indeterminates!");      
+    ERROR("The basering should have precisely two indeterminates!");
   }
   // -1) Exclude the pathological case that the defining tropical polynomial has only one term,
@@ -910,5 +910,5 @@
     intmat M[2][1]=0,0;
     return(list(list(0,0,M,list(),detropicalise(tp[1])),list(list(leadexp(detropicalise(tp[1]))),list())));
-  }    
+  }
   // 0) If the input was a list of linear polynomials, then some coefficient of x or y can be negative,
   //    i.e. the input corresponds to the tropical curve of a Laurent polynomial. In that case we should
@@ -925,5 +925,5 @@
     {
       bb=koeffizienten(tp[i],2);
-    }    
+    }
   }
   if ((aa!=0) or (bb!=0))
@@ -942,11 +942,11 @@
     return(bunchOfLines(tp));
   }
-  // 2) store all vertices belonging to the ith part of the 
+  // 2) store all vertices belonging to the ith part of the
   //    Newton subdivision in the list vtp[i] as 4th entry,
   //    and store those, which are not corners of the ith subdivision polygon
   //    in vtp[i][6]
-  poly nwt; 
+  poly nwt;
   list boundaryNSD;  // stores the boundary of a Newton subdivision
-  intmat zwsp[2][1]; // used for intermediate storage    
+  intmat zwsp[2][1]; // used for intermediate storage
   for (i=1;i<=size(vtp);i++)
   {
@@ -954,5 +954,5 @@
     nwt=vtp[i][3]; // the polynomial representing the ith part of the Newton subdivision
     // store the vertices of the ith part of the Newton subdivision in the list newton
-    list newton;  
+    list newton;
     while (nwt!=0)
     {
@@ -964,5 +964,5 @@
     vtp[i][4]=boundaryNSD[1];
     vtp[i][5]=boundaryNSD[2];
-    vtp[i][6]=zwsp; // the entries of the first row will denote to which vertex the ith one is connected 
+    vtp[i][6]=zwsp; // the entries of the first row will denote to which vertex the ith one is connected
                  // and the entries of the second row will denote with which multiplicity
     kill newton; // we kill the superflous list
@@ -984,5 +984,5 @@
     kill ipairs;
   }
-  // 4) Check for all pairs of verticies in the Newton diagram if they 
+  // 4) Check for all pairs of verticies in the Newton diagram if they
   //    occur in two different parts of the Newton subdivision
   int deleted; // if a pair occurs in two NSD, it can be removed from both - deleted is then set to 1
@@ -991,5 +991,5 @@
   d=1;  // counts the inner edges
   for (i=1;i<=size(pairs)-1;i++)
-  {  
+  {
     for (j=i+1;j<=size(pairs);j++)
     {
@@ -998,5 +998,5 @@
         deleted=0;
         for (l=size(pairs[j]);l>=1 and deleted==0;l--)
-        {  
+        {
           if (((pairs[i][k][1]==pairs[j][l][1]) and (pairs[i][k][2]==pairs[j][l][2])) or ((pairs[i][k][1]==pairs[j][l][2]) and (pairs[i][k][2]==pairs[j][l][1])))
           {
@@ -1062,5 +1062,5 @@
   for (i=1;i<=size(pairs);i++)
   {
-    list ubedges; // stores the unbounded edges 
+    list ubedges; // stores the unbounded edges
     k=1; // counts the unbounded edges
     for (j=1;j<=size(pairs[i]);j++)
@@ -1114,5 +1114,5 @@
     gr[3]=vtp[i][6];  // to which vertices is the ith vertex of the tropical curve connected
     gr[4]=vtp[i][7];  // the directions unbounded edges emerging from the ith vertex of the trop. curve
-    gr[5]=vtp[i][3];  // the vertices of the boundary of the ith part of the NSD 
+    gr[5]=vtp[i][3];  // the vertices of the boundary of the ith part of the NSD
     graph[i]=gr;
   }
@@ -1149,24 +1149,24 @@
 // the coordinates of the first vertex are graph[1][1],graph[1][2];
    graph[1][1],graph[1][2];
-// the first vertex is connected to the vertices 
+// the first vertex is connected to the vertices
 //     graph[1][3][1,1..ncols(graph[1][3])]
    intmat M=graph[1][3];
    M[1,1..ncols(graph[1][3])];
-// the weights of the edges to these vertices are 
+// the weights of the edges to these vertices are
 //     graph[1][3][2,1..ncols(graph[1][3])]
    M[2,1..ncols(graph[1][3])];
 // from the first vertex emerge size(graph[1][4]) unbounded edges
    size(graph[1][4]);
-// the primitive integral direction vector of the first unbounded edge 
+// the primitive integral direction vector of the first unbounded edge
 //     of the first vertex
    graph[1][4][1][1];
 // the weight of the first unbounded edge of the first vertex
    graph[1][4][1][2];
-// the monomials which are part of the Newton subdivision of the first vertex 
+// the monomials which are part of the Newton subdivision of the first vertex
    graph[1][5];
-// connecting the points in graph[size(graph)][1] we get 
+// connecting the points in graph[size(graph)][1] we get
 //     the boundary of the Newton polytope
    graph[size(graph)][1];
-// an entry in graph[size(graph)][2] is a pair of points 
+// an entry in graph[size(graph)][2] is a pair of points
 //     in the Newton polytope bounding an inner edge
    graph[size(graph)][2][1];
@@ -1175,17 +1175,17 @@
 proc drawTropicalCurve (def f,list #)
 "USAGE:      drawTropicalCurve(f[,#]); f poly or list, # optional list
-ASSUME:      f is list of linear polynomials of the form ax+by+c with integers a, b and a rational number c 
+ASSUME:      f is list of linear polynomials of the form ax+by+c with integers a, b and a rational number c
              representing a tropical Laurent polynomial defining a tropical plane curve;
              alternatively f can be a polynomial in Q(t)[x,y] defining a tropical plane curve
-             via the valuation map; 
+             via the valuation map;
              the basering must have a global monomial ordering, two variables and up to one parameter!
 RETURN:      NONE
-NOTE:        - the procedure produces the files /tmp/tropicalcurveNUMBER.tex and 
-               /tmp/tropicalcurveNUMBER.ps, where NUMBER is a random four digit integer; 
+NOTE:        - the procedure produces the files /tmp/tropicalcurveNUMBER.tex and
+               /tmp/tropicalcurveNUMBER.ps, where NUMBER is a random four digit integer;
                moreover it displays the tropical curve defined by f via kghostview;
                if you wish to remove all these files from /tmp, call the procedure cleanTmp
 @*           - edges with multiplicity greater than one carry this multiplicity
 @*           - if # is empty, then the tropical curve is computed w.r.t. minimum, if #[1] is the
-               string 'max', then it is computed w.r.t. maximum 
+               string 'max', then it is computed w.r.t. maximum
 @*           - if the last optional argument is 'onlytexfile' then only the latex file
                is produced; this option should be used if kghostview is not installed on
@@ -1212,5 +1212,5 @@
     if ((npars(basering)!=1) or (nvars(basering)!=2))
     {
-      ERROR("The basering should have precisely one parameter and two indeterminates!");      
+      ERROR("The basering should have precisely one parameter and two indeterminates!");
     }
     texf=texPolynomial(f); // write the polynomial over Q(t)
@@ -1223,9 +1223,9 @@
       texf="\\mbox{\\tt The defining equation was not handed over!}";
       list graph=f;
-    }   
+    }
     else
     { // write the tropical polynomial defined by f
       if (size(#)==0)
-      {      
+      {
         texf="\\min\\{";
       }
@@ -1236,5 +1236,5 @@
       for (j=1;j<=size(f);j++)
       {
-        texf=texf+texPolynomial(f[j]);    
+        texf=texf+texPolynomial(f[j]);
         if (j<size(f))
         {
@@ -1245,5 +1245,5 @@
           texf=texf+"\\}";
         }
-      }    
+      }
       list graph=tropicalCurve(f,#); // the graph of the tropical polynomial f
     }
@@ -1263,17 +1263,17 @@
 \\addtolength{\\topmargin}{-\\headheight}
 \\addtolength{\\topmargin}{-\\topskip}
-\\setlength{\\textheight}{267mm} 
+\\setlength{\\textheight}{267mm}
 \\addtolength{\\textheight}{\\topskip}
 \\addtolength{\\textheight}{-\\footskip}
 \\addtolength{\\textheight}{-30pt}
-\\setlength{\\oddsidemargin}{-1in} 
+\\setlength{\\oddsidemargin}{-1in}
 \\addtolength{\\oddsidemargin}{20mm}
 \\setlength{\\evensidemargin}{\\oddsidemargin}
-\\setlength{\\textwidth}{170mm} 
+\\setlength{\\textwidth}{170mm}
 
 \\begin{document}
    \\parindent0cm
    \\begin{center}
-      \\large\\bf The Tropicalisation of 
+      \\large\\bf The Tropicalisation of
 
       \\bigskip
@@ -1299,5 +1299,5 @@
 
    \\begin{center}
-       "+texDrawNewtonSubdivision(graph,#)+" 
+       "+texDrawNewtonSubdivision(graph,#)+"
    \\end{center}
 \\end{document}";
